///////////////////////////////////////////////////////////////////////////////////////////////////
// OpenGL Mathematics Copyright (c) 2005 - 2008 G-Truc Creation (www.g-truc.net)
///////////////////////////////////////////////////////////////////////////////////////////////////
// Created : 2005-12-21
// Updated : 2005-12-27
// Licence : This source is under MIT License
// File    : glm/gtx/optimum_pow.inl
///////////////////////////////////////////////////////////////////////////////////////////////////

namespace glm
{
    template <typename genType> 
    inline genType pow2GTX(const genType& x)
    {
        return x * x;
    }

    template <typename genType> 
    inline genType pow3GTX(const genType& x)
    {
        return x * x * x;
    }

    template <typename genType> 
    inline genType pow4GTX(const genType& x)
    {
        return x * x * x * x;
    }

    inline bool powOfTwoGTX(int x)
    {
        return !(x & (x - 1));
    }

    inline detail::tvec2<bool> powOfTwoGTX(const detail::tvec2<int>& x)
    {
        return detail::tvec2<bool>(
            powOfTwoGTX(x.x),
            powOfTwoGTX(x.y));
    }

    inline detail::tvec3<bool> powOfTwoGTX(const detail::tvec3<int>& x)
    {
        return detail::tvec3<bool>(
            powOfTwoGTX(x.x),
            powOfTwoGTX(x.y),
            powOfTwoGTX(x.z));
    }

    inline detail::tvec4<bool> powOfTwoGTX(const detail::tvec4<int>& x)
    {
        return detail::tvec4<bool>(
            powOfTwoGTX(x.x),
            powOfTwoGTX(x.y),
            powOfTwoGTX(x.z),
            powOfTwoGTX(x.w));
    }
}
